/** * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* ColoredUnitCube.js
* A cube with colored vertices.
* Copyright (c) Schell Scivally. All rights reserved.
* 
* @author	Schell Scivally
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * **/
mod({
    name : 'ColoredUnitCube',
    dependencies : [ 'bang3d::Geometry/Mesh.js' ],
    /** * *
    * Initializes the ColoredUnitCube object constructor.
    * @param {function} Mesh The Mesh object constructor.
    * * **/
    init : function ColoredUnitCubeFactory (Mesh) {
        /** * *
        * Creates a new colored cube mesh!
        * @constructor
        * * **/
        function ColoredUnitCube() {
        	Mesh.prototype.constructor.call(this,
                // positions        // colors
                 1.0,  1.0,  1.0,   1.0, 1.0, 1.0, 1.0, // top face
                -1.0,  1.0,  1.0,   0.0, 1.0, 1.0, 1.0, //
                 1.0, -1.0,  1.0,   1.0, 0.0, 1.0, 1.0, //
 							 							//
                -1.0,  1.0,  1.0,   0.0, 1.0, 1.0, 1.0, //
                 1.0, -1.0,  1.0,   1.0, 0.0, 1.0, 1.0, //
                -1.0, -1.0,  1.0,   0.0, 0.0, 1.0, 1.0, //


                 1.0,  1.0, -1.0,   1.0, 1.0, 0.0, 1.0,	// bottom face
                -1.0,  1.0, -1.0,   0.0, 1.0, 0.0, 1.0,	//
                 1.0, -1.0, -1.0,   1.0, 0.0, 0.0, 1.0,	//
														//
                -1.0,  1.0, -1.0,   0.0, 1.0, 0.0, 1.0,	//
                 1.0, -1.0, -1.0,   1.0, 0.0, 0.0, 1.0,	//
                -1.0, -1.0, -1.0,   0.0, 0.0, 0.0, 1.0,	//

                 1.0,  1.0,  1.0,   1.0, 1.0, 1.0, 1.0, // back face
                -1.0,  1.0,  1.0,   0.0, 1.0, 1.0, 1.0, //
                 1.0,  1.0, -1.0,   1.0, 1.0, 0.0, 1.0, //
 						  							
                -1.0,  1.0,  1.0,   0.0, 1.0, 1.0, 1.0, //
                 1.0,  1.0, -1.0,   1.0, 1.0, 0.0, 1.0, //
                -1.0,  1.0, -1.0,   0.0, 1.0, 0.0, 1.0, //

                 1.0,  -1.0,  1.0,  1.0, 0.0, 1.0, 1.0, // front face
                -1.0,  -1.0,  1.0,  0.0, 0.0, 1.0, 1.0, //
                 1.0,  -1.0, -1.0,  1.0, 0.0, 0.0, 1.0, //
 						  							
                -1.0,  -1.0,  1.0,  0.0, 0.0, 1.0, 1.0, //
                 1.0,  -1.0, -1.0,  1.0, 0.0, 0.0, 1.0, //
                -1.0,  -1.0, -1.0,  0.0, 0.0, 0.0, 1.0, //

                -1.0,  1.0,  1.0,   0.0, 1.0, 1.0, 1.0, // left face
                -1.0, -1.0,  1.0,   0.0, 0.0, 1.0, 1.0, //
                -1.0,  1.0, -1.0,   0.0, 1.0, 0.0, 1.0, //
 				    							
                -1.0, -1.0,  1.0,   0.0, 0.0, 1.0, 1.0, //
                -1.0,  1.0, -1.0,   0.0, 1.0, 0.0, 1.0, //
                -1.0, -1.0, -1.0,   0.0, 0.0, 0.0, 1.0, //

                 1.0,  1.0,  1.0,   1.0, 1.0, 1.0, 1.0, // right face
                 1.0, -1.0,  1.0,   1.0, 0.0, 1.0, 1.0, //
                 1.0,  1.0, -1.0,   1.0, 1.0, 0.0, 1.0, //
 				    							
                 1.0, -1.0,  1.0,   1.0, 0.0, 1.0, 1.0, //
                 1.0,  1.0, -1.0,   1.0, 1.0, 0.0, 1.0, //
                 1.0, -1.0, -1.0,   1.0, 0.0, 0.0, 1.0  //
        	)
        }
        
        ColoredUnitCube.prototype = new Mesh();
        
        ColoredUnitCube.prototype.constructor = ColoredUnitCube;
        //--------------------------------------
        //  METHODS
        //--------------------------------------
        
        
        return ColoredUnitCube;
    }
});
